//参数库
const param = (value, node, keyList) => {
  const [paramLibId, paramId] = value;
  const { name: paramLibName, children, data: libData } = keyList.find(v => v.id === paramLibId);
  const { description: paramLibLabel } = libData;
  const { name: paramName, data: paramData } = children.find(v => v.id === paramId);
  const { description: paramLabel, type: type } = paramData;
  node.paramLibName = paramLibName;
  node.paramLibLabel = paramLibLabel;
  node.paramName = paramName;
  node.paramLabel = paramLabel;
  node.paramLibId = paramLibId;
  node.datatype = type;
  node.paramId = paramId;
};
//常量库
const constant = (value, node, constantList) => {
  const [constantLibId, constantId] = value;
  const { name: constantLibName, children } = constantList.find(v => v.id === constantLibId);
  const { data: constantData } = children.find(v => v.id === constantId);

  const { name: constantLabel, value: constantValue, type: datatype } = constantData;
  node.constantLibName = constantLibName;
  node.constantValue = constantValue;
  node.constantLabel = constantLabel;
  node.constantLibId = constantLibId;
  node.datatype = datatype;
  node.constantId = constantId;
};
//方法库
const methods = (value, data, methodList) => {
  const [beanId, methodId] = value;
  const { name: beanName, children, data: libData } = methodList.find(v => v.id === beanId);
  const { description: beanLabel, version: beanVersion } = libData;
  data.actionId = beanId;
  data.beanVersion = beanVersion;
  data.beanName = beanName;
  data.beanLabel = beanLabel;
  const { name: methodName, data: paramData } = children.find(v => v.id === methodId);
  const { description: methodLabel } = paramData;
  data.methodName = methodName;
  data.methodLabel = methodLabel;
};
//数据搜集
const dataCollection = (node, keyList) => {
  const { name: paramLibName, data: libData } = keyList.find(v => v.id === node.paramLibId);
  const { description: paramLibLabel } = libData;
  node.paramLibName = paramLibName;
  node.paramLibLabel = paramLibLabel;
};
export { param, constant, methods, dataCollection };
