const schema = [
  {
    prop: "name",
    label: "名称",
    type: "input",
    props: {
      placeholder: "请填写名称",
      showWordLimit: true,
      maxlength: 20
    },
    rules: [
      {
        required: true,
        message: "请填写名称"
      }
    ]
  },
  {
    prop: "key",
    label: "key",
    type: "input",
    props: {
      placeholder: "请填写key",
      showWordLimit: true,
      maxlength: 100
    },
    rules: [
      {
        required: true,
        message: "请填写key"
      }
    ]
  },
  {
    prop: "iconUrl",
    label: "图标",
    type: "upload-file",
    props: {
      placeholder: "请上传图标",
      type: "image",
      data: {
        groupId: "B1855275E53E4568B3FCBA2C6111BDB8"
      }
    }
  },
  {
    prop: "desc",
    label: "描述",
    type: "input",
    props: {
      type: "textarea",
      placeholder: "请填写描述",
      showWordLimit: true,
      maxlength: 100
    }
  }
];

export default {
  "config.title": "模板列表",
  "config.toolbar.edit.disabled": ({ component }) => {
    return !component("list2").action("getActive");
  },
  "config.toolbar.delete.disabled": ({ component }) => {
    return !component("list2").action("getActive");
  },
  "events.change": async ({ dispatch }) => {
    await dispatch("queryTemplateVersion", {
      init: true
    });
  },
  "events.toolbarClick/create": async ({ dispatch, modal }) => {
    modal({
      data: {},
      title: "新建模板",
      schema,
      onConfirm: async ({ data, close }) => {
        await dispatch("createTemplate", data);
        await dispatch("queryTemplate");
        close();
      }
    });
  },
  "events.toolbarClick/edit": async ({ dispatch, component, modal }) => {
    const active = component("list2").action("getActive");
    modal({
      data: active,
      title: "编辑模板",
      schema,
      onConfirm: async ({ data, close }) => {
        await dispatch("editTemplate", data);
        await dispatch("queryTemplate");
        close();
      }
    });
  },
  "events.toolbarClick/delete": async ({ dispatch, component, confirm }) => {
    const active = component("list2").action("getActive");
    confirm({
      title: "是否删除",
      content: "即将删除所选数据，是否继续",
      confirmButtonText: "删除",
      cancelButtonText: "关闭",
      closeOnClickModal: false,
      onConfirm: async () => {
        await dispatch("deleteTemplate", {
          ids: active.id
        });
        await dispatch("queryTemplate");
      }
    });
  }
};
