import pageData from "../data";
// 查重
import fetch from "@/utils/fetch";  
export const repeatNamess = data => fetch("/design/component/templateVersion/byCondition", { templateId: repeatNameKey, version: replaceData(data) }, "POST");
let repeatNameKey = "";
let oldVersion = "";
function replaceData(data) {
  console.log("reloacedata", data)
  if (data == oldVersion) {
    return " "
  } else {
    return data
  }
}
const tableSchema = [
  {
    prop: "templateKey",
    label: "名称",
  },
  {
    prop: "version",
    label: "版本",
  },
  {
    prop: "desc",
    label: "描述",
  },
  {
    prop: "status",
    label: "状态",
    render(data) {
      const map = {
        online: "上线",
        offline: "下线",
      };
      return map[data];
    },
  },
];
const schema = () => {
  return [
    {
      prop: "version",
      label: "版本",
      type: "input",
      props: {
        placeholder: "请填写版本",
        showWordLimit: true,
        maxlength: 50,
      },
      rules: [
        {
          required: true,
          message: "请填写版本",
        },
        {
          pattern: /^([0-9]\d|[0-9])(\.([0-9]\d|\d)){2}$/,
          message: "版本号格式为x.x.x三位数字格式",
        },
        {
          validator: async function (rule, value, callback) {
            if (oldVersion == value) {
              return callback()
            } else {
              const a = await repeatNamess(value)
              if (a.content.length > 0) {
                return callback(new Error("版本号已使用，请重试"))
              } else {
                return callback()
              }
            }

          }
        }
      ],
    },
    {
      prop: "desc",
      label: "描述",
      type: "input",
      props: {
        type: "textarea",
        placeholder: "请填写描述",
        showWordLimit:true,
        maxlength:100
      },
    },
  ];
};
export default {
  "config.schema": tableSchema,
  "events.pageChange": async ({ dispatch }) => {
    await dispatch("queryTemplateVersion");
  },
  "config.actionbar.delete.show": false,
  "config.actionbar.design": {
    order: 2,
    show: true,
    disabled: false,
    type: "text",
    size: "small",
    text: "设计",
  },
  "config.actionbar.online": {
    order: 3,
    show: (options, item, data) => data.status === "offline",
    disabled: false,
    type: "text",
    size: "small",
    text: "上线",
  },
  "config.actionbar.offline": {
    order: 4,
    show: (options, item, data) => data.status === "online",
    disabled: false,
    type: "text",
    size: "small",
    text: "下线",
  },
    "config.toolbar.import": {
        order: 5,
        show: true,
        disabled: false,
        type: "success",
        size: "small",
        text: "导入",
    },
    "config.toolbar.export": {
        order: 6,
        show: true,
        disabled: false,
        type: "info",
        size: "small",
        text: "导出",
    },
  "config.toolbar.create.text": "新建版本",
  "config.toolbar.create.disabled": ({ component }) => {
    return (
      !component("list1").action("getActive") ||
      !component("list2").action("getActive")
    );
  },
  "config.toolbar.delete.disabled": ({ component }) => {
    return !component("table").action("getSelection").length;
  },
  "events.search": async ({ dispatch }) => {
    dispatch("queryTemplateVersion");
  },
  "events.toolbarClick/create": async ({ dispatch, component, modal }) => {
   
    const createListData = component(
      "list2"
    ).action("getActive");
    repeatNameKey = createListData.id;
    console.log("repeatNameKey: ", repeatNameKey)  
    modal({
      data: {},
      title: "新建模板版本",
      width: "800px",
      confirmText: "确定",
      showCancel: false,
      schema: schema({ component }),
      onConfirm: async ({ data, close }) => {
        const { id: groupId, key: groupKey } = component("list1").action(
          "getActive"
        );
        const { id: templateId, key: templateKey } = component("list2").action(
          "getActive"
        );
        await dispatch("createTemplateVersion", {
          ...data,
          groupId,
          groupKey,
          templateId,
          templateKey,
          templateJson: JSON.stringify(pageData()),
        });
        close();
      },
    });
  },
  "events.toolbarClick/delete": async ({ dispatch, component, confirm }) => {
    const selection = component("table").action("getSelection");
    const ids = selection.map((v) => v.id).join(",");
    confirm({
      title: "是否删除",
      content: "即将删除所选数据，是否继续",
      confirmButtonText: "删除",
      cancelButtonText: "关闭",
      closeOnClickModal: false,
      onConfirm: async () => {
        await dispatch("deleteTemplateVersion", {
          ids,
        });
      },
    });
  },

  "events.actionbarClick/edit": async (
    { dispatch, modal, component },
    payload
  ) => {
    const { row } = payload;
    repeatNameKey = payload.row.componentId;
    oldVersion = payload.row.version
    console.log("repeatNameKey:", repeatNameKey, payload)
    modal({
      data: row,
      title: "编辑模板版本",
      width: "800px",
      confirmText: "确定",
      showCancel: false,
      schema: schema({ component }),
      onConfirm: async ({ data, close }) => {
        await dispatch("editTemplateVersion", data);
        close();
      },
    });
  },
  "events.actionbarClick/online": async ({ dispatch, confirm }, payload) => {
    const { row } = payload;
    confirm({
      title: "是否上线",
      content: "即将上线所选数据，是否继续",
      confirmButtonText: "上线",
      cancelButtonText: "关闭",
      onConfirm: async () => {
        await dispatch("editTemplateVersion", { id: row.id, status: "online" });
      },
    });
  },
  "events.actionbarClick/offline": async ({ dispatch, confirm }, payload) => {
    const { row } = payload;
    confirm({
      title: "是否下线",
      content: "即将下线所选数据，是否继续",
      confirmButtonText: "下线",
      cancelButtonText: "关闭",
      onConfirm: async () => {
        await dispatch("editTemplateVersion", {
          id: row.id,
          status: "offline",
        });
      },
    });
  },
};
